<?php



require_once( dirname(__FILE__).'../../../autoload.php' );



if (!defined("ABSPATH")) {

    exit;

}





if ( ! class_exists( 'BindCommerce_Ajax_Mapping_Order_States' ) ) {



    /**

     * 

     * Tha ajax class that allow to Create/Update mapping order state

     *

     * @since 1.0.0

     * 

     */ 

    class BindCommerce_Ajax_Mapping_Order_States extends BindCommerce {



        public function init()

        {     

            

            // CHECK token

            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) { 



                BindCommerce_Logger::error( __('Il token di sicurezza per effettuare la richiesta non è valido.', BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );                

                

                return json_encode( [

                    "status"    => "error",

                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }   



            // CHECK request

            if ( !isset($_POST["bindcommerce_mapping_order_states"]) || empty($_POST["bindcommerce_mapping_order_states"]) ) {



                BindCommerce_Logger::error( __("La richiesta per il mapping degli stati d'ordine non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true  );

                

                return json_encode( [

                    "status" => "error",

                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("La richiesta per il mapping degli stati d'ordine non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }

            

            // PROCESS request

            $errors = [];



            foreach ($_POST['bindcommerce_mapping_order_states'] as $key => $order_state) { 



                $delete_order_state = (bool) $order_state["bindcommerce_order_state_delete"];



                if (empty($order_state["bindcommerce_order_state_name"]) && !$delete_order_state 

                    || empty($order_state["bindcommerce_wc_order_state_id"]) && !$delete_order_state) 

                {

                    continue;

                }



                BindCommerce_Mapping::order_state(

                    $order_state["bindcommerce_mapping_active"],

                    $order_state["bindcommerce_mapping_order_id"],

                    $order_state["bindcommerce_order_state_name"],

                    $order_state["bindcommerce_wc_order_state_id"],

                    $order_state["bindcommerce_wc_new_order_stock_type"],

                    $order_state["bindcommerce_wc_update_order_stock_type"],

                    $delete_order_state

                );

                

            }

            

            if ( empty($errors) ) {

                

                BindCommerce_Logger::info( __("Mapping salvato e aggiornato correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                return json_encode( [

                    "status" => "success",

                    "message" => __("Impostazioni salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("Tutti gli stati sono stati salvati e aggiornati correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            } else {

                

                BindCommerce_Logger::error( __("Alcune impostazioni non sono state salvate, per maggiori informazioni consulta i log catturati nella sezione dedicata", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true  );

                

                return json_encode( [

                    "status" => "error",

                    "message" => __("Impossibile aggiornare e salvare i mapping impostati", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => $errors

                ]);

                

            }      

            

        }

        

    }



}



$bindcommerce_ajax = new BindCommerce_Ajax_Mapping_Order_States();

header('Content-Type: application/json; charset=utf-8');

echo json_encode($bindcommerce_ajax->init());

die();



?>