<?php



require_once( dirname(__FILE__).'../../../autoload.php' );



if (!defined("ABSPATH")) {

    exit;

}



global $wpdb;

$table_name = $wpdb->prefix . BINDCOMMERCE_DB_TABLE_OPTIONS;





if ( ! class_exists( 'BindCommerce_Ajax_Settings' ) ) {



    /**

     * 

     * Tha ajax class that allow to save and update bindCommerce settings

     *

     * @since 1.0.1

     * 

     */ 

    class BindCommerce_Ajax_Settings extends BindCommerce {



        public function init()

        {        



            // CHECK token

            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) {       

                

                return json_encode( [

                    "status"    => "error",

                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }



            // CHECK request            

            if ( !isset($_POST["bindcommerce_update_options"]) || empty($_POST["bindcommerce_update_options"]) ) {  



                BindCommerce_Logger::error( __("La richiesta per l'aggiornamento delle impostazioni non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );

            

                return json_encode( [

                    "status" => "error",

                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("La richiesta per l'aggiornamento delle impostazioni non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }



            // PROCESS request 

            $errors = [];



            foreach ($_POST['bindcommerce_update_options'] as $key => $value) { 



                $value_error = false;

                $product_mode = false;



                if ($key == "bindcommerce_products_import_mode") {



                    $modes = (array)unserialize( BindCommerce_Setting::get_product_mode() );



                    foreach ( $modes as $mode ) { 



                        if ( $mode == $value ) {



                            $product_mode = true;



                        }

                        

                    }



                    if ( !$product_mode ) {



                        BindCommerce_Logger::error( __("Il codice di esportazione attribuito non è valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                        $errors[] = [

                            "data" => __( "Il codice di esportazione attribuito non è valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;

                    }

                    

                }

                

                if ($key == "bindcommerce_products_import_prefix") {



                    if ( !preg_match('/^[a-zA-Z0-9_]+$/', $value) ) {

                        

                        BindCommerce_Logger::error( __("Il prefisso dei prodotti non può contenere caratteri speciali", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                        $errors[] = [

                            "data" => __( "Il prefisso dei prodotti non può contenere caratteri speciali", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;



                    }

                    if (strlen($value) < 3) {



                        BindCommerce_Logger::error( __("Il prefisso dei prodotti è troppo corto, inserisci almeno 3 caratteri", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                        $errors[] = [

                            "data" => __( "Il prefisso dei prodotti è troppo corto, inserisci almeno 3 caratteri", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;



                    }

                    if (strlen($value) > 10) {



                        BindCommerce_Logger::error( __( "Il prefisso dei prodotti è troppo lungo, inserisci al massimo 10 caratteri", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                        $errors[] = [

                            "data" => __( "Il prefisso dei prodotti è troppo lungo, inserisci al massimo 10 caratteri", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;



                    }

                    

                }



                if ($key == "bindcommerce_products_tax_value_amount") {

                

                    $product_tax_amount = sanitize_text_field($value);

                    $product_tax_amount = str_replace(",", ".", $product_tax_amount);

                    $product_tax_amount = str_replace("%", "", $product_tax_amount);

                    $product_tax_amount = str_replace(" ", "", $product_tax_amount);

            

                    if (!empty($product_tax_amount) && !is_numeric($product_tax_amount)) {



                        BindCommerce_Logger::error( __( "L'importo indicato nel campo Ricarico IVA non è un formato valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) ); 



                        $errors[] = [

                            'data' => __( "L'importo indicato nel campo Ricarico IVA non è un formato valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;

                    }     



                    if ($product_tax_amount == "0") {

                        $value = "";

                    }       



                }



                if ($key == "bindcommerce_products_supplement_value_amount") {

                

                    $product_supplement_amount = sanitize_text_field($value);

                    $product_supplement_amount = str_replace(",", ".", $product_supplement_amount);

                    $product_supplement_amount = str_replace("%", "", $product_supplement_amount);

                    $product_supplement_amount = str_replace(" ", "", $product_supplement_amount);

            

                    if (!empty($product_supplement_amount) && !is_numeric($product_supplement_amount)) {



                        BindCommerce_Logger::error( __("L'importo indicato nel campo Ricarico bindCommerce non è un formato valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                        $errors[] = [

                            'data' => __( "L'importo indicato nel campo Ricarico bindCommerce non è un formato valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                        ];

                        $value_error = true;



                    }      



                    if ($product_supplement_amount == "0") {

                        $value = "";

                    }  



                }



                if ($key == "bindcommerce_debug_notify_email_list" && !empty($value) ) {

                

                    $emails = $value;

                    

                    if (strpos($emails, ',') !== false) {



                        $emails = explode(",", $emails); 

    

                    } else {

    

                        $arr = [];

                        $arr[] = $emails;

                        $emails = $arr;

    

                    }

    

                    foreach ($emails as $email) {



                        $email = trim($email);

    

                        if ( !is_email( $email ) ) {                                

    

                            BindCommerce_Logger::error( __("Il campo email non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                            $errors[] = [

                                'data' => __( "Il campo email non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                            ];

                            $value_error = true;

                            break;   



                        }

    

                    }                 



                }

                

                if (!$value_error) {

                    

                    if ( $product_mode ) { 



                        if ($value == "id") {



                            $data = [ 

                                'option_value' => stripslashes_deep( serialize([ 

                                        "id"       => true,

                                        "cod"      => "",

                                    ])

                                ) 

                            ];



                        }

                        

                        if ($value == "cod") {



                            $data = [ 

                                'option_value' => stripslashes_deep( serialize([ 

                                        "id"       => "",

                                        "cod"      => true,

                                    ])

                                ) 

                            ];



                        }



                    } else {



                        $data = [ 

                            'option_value' => stripslashes_deep(trim($value)) 

                        ];



                    }



                    $where = [ 

                        'option_name' => stripslashes_deep(trim($key)) 

                    ];



                    global $wpdb;

                    

                    $wpdb->update(

                        $wpdb->prefix . BINDCOMMERCE_DB_TABLE_OPTIONS,

                        $data, 

                        $where 

                    );



                } 

                

            } 

            

            if ( empty($errors) ) {



                BindCommerce_Logger::info( __("Tutte le impostazioni sono state salvate e aggiornate correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                return json_encode( [

                    "status" => "success",

                    "message" => __("Impostazioni salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("Tutte le impostazioni sono state salvate e aggiornate correttamente", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ],

                ]);



            } else {



                BindCommerce_Logger::error( __("Alcune impostazioni non sono state salvate, per maggiori informazioni consulta i log catturati nella sezione dedicata", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );



                return json_encode( [

                    "status" => "error",

                    "message" => __("Alcune impostazioni non sono state salvate", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => $errors,

                ]);

                

            }            



        }



    }



}



$bindcommerce_ajax = new BindCommerce_Ajax_Settings();

header('Content-Type: application/json; charset=utf-8');

echo json_encode($bindcommerce_ajax->init());

die();



?>