<?php



require_once( dirname(__FILE__).'../../../autoload.php' );



if (!defined("ABSPATH")) {

    exit;

}





if ( !class_exists('BindCommerce_Ajax_Update_WC_Order') ) {



    /**

     * 

     * Tha ajax class that allow to import orders from bindCommerce to WooCommerce

     *

     * @since 1.0.1

     * 

     */ 

    class BindCommerce_Ajax_Update_WC_Order extends BindCommerce {



        public function init()

        {    



            // CHECK token

            if ( !isset($_POST["bindcommerce_ajax_token"]) || !BindCommerce_Cron::is_valid_token($_POST["bindcommerce_ajax_token"]) ) {             

                

                return json_encode( [

                    "status"    => "error",

                    "message"   => __("Token di sicurezza non valido", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("Il token di sicurezza per effettuare la richiesta non è valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }    

            

            // CHECK request

            if ( !isset($_POST["bindcommerce_import_order"]) || empty($_POST["bindcommerce_import_order"]) ) {  



                BindCommerce_Logger::error( __("La richiesta per l'importazione degli ordini non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );



                return json_encode( [

                    "status" => "error",

                    "message" => __("Impossibile completare la richiesta", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs" => [ 

                        0 => [

                            "data" => __("La richiesta per l'importazione degli ordini non è valida", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                        ]

                    ]

                ]);



            }



            // PROCESS request



            $errors             = [];

            $order_ids          = $_POST["bindcommerce_import_order"];   

            $import_new_orders  = json_decode($_POST["bindcommerce_import_new_order"]); // true/false



            if ( isset($_POST["bindcommerce_import_orders_order_by"]) && empty(["bindcommerce_import_orders_order_by"]) ) {



                BindCommerce_Logger::error( __("Ordinamento Sync non valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                $errors[] = [

                    "data" => __( "Ordinamento Sync non valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                ];



            }

            

            if ( !empty($errors) ) {



                BindCommerce_Logger::error( __("Impossibile completare la sincronizzazione, per maggiori informazioni consulta i log catturati nella sezione dedicata", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );



                return json_encode( [

                    "status"    => "error",

                    "message"   => __("Impossibile completare la sincronizzazione", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs"      => $errors

                ]);



            }



            if ( isset($_POST["bindcommerce_import_orders_limit"]) && is_numeric($_POST["bindcommerce_import_orders_limit"]) 

                || isset($_POST["bindcommerce_import_orders_limit"]) && empty($_POST["bindcommerce_import_orders_limit"])         

                || isset($_POST["bindcommerce_import_orders_limit"]) && $_POST["bindcommerce_import_orders_limit"] == "-1"

                || !isset($_POST["bindcommerce_import_orders_limit"]) ) 

            { 



                $sync = json_decode( BindCommerce_API::import_orders( 

                    $order_ids, 

                    $_POST["bindcommerce_import_orders_limit"], 

                    $_POST["bindcommerce_import_orders_order_by"], 

                    $import_new_orders 

                ), true );

                

                if (isset($sync["status"]) && $sync["status"] == "error") {

                    

                    $errors[] = [

                        "data" => $sync["message"]

                    ];



                }



            } else {



                BindCommerce_Logger::error( __( "Limite Sync non valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



                $errors[] = [

                    "data" => __( "Limite Sync non valido.", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN)

                ];



            }  



            if ( !empty($errors) ) {



                BindCommerce_Logger::error( __("UPDATE Ordini: Impossibile aggiornare gli ordini, per maggiori informazioni consulta i log catturati nella sezione dedicata", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN), "", true );



                return json_encode( [

                    "status"    => "error",

                    "message"   => __("Impossibile aggiornare gli ordini", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                    "logs"      => $errors

                ]);



            } 



            BindCommerce_Logger::info( __("UPDATE Ordini: Aggiornamento completato", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) );



            return json_encode( [

                "status"    => "success",

                "message"   => __("Aggiornamento completato", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN),

                "logs"      => [ 

                    0 => [

                        "data" => __("Tutti i contenuti sono stati correttamente aggiornati", BINDCOMMERCE_PLUGIN_TEXT_DOMAIN) 

                    ]

                ],

            ]);



        }



    }



}



$bindcommerce_ajax = new BindCommerce_Ajax_Update_WC_Order();

header('Content-Type: application/json; charset=utf-8');

echo json_encode($bindcommerce_ajax->init());

die();



?>