<?php 



if ( ! defined( 'ABSPATH' ) ) { 

    exit; 

}





if ( !function_exists("bindcommerce_get_imported_orders_count") ) {



    /**

     * 

     * Get BindCommerce orders count

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_get_imported_orders_count() {

        

        $orders_count = BindCommerce_DB::get_result("



            SELECT COUNT(sync_id)

            FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_DB_TABLE_SYNC_IMPORT_ORDERS . ";



        ");



        if ( is_numeric($orders_count) ) {

            return $orders_count;

        }

        

        return 0;



    }



}



if ( !function_exists("bindcommerce_get_wc_products") ) {



    /**

     * 

     * Get All WooCommerce Products

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_get_wc_products( $args ) {     



        //return get_posts( $args ); 

        return wc_get_products( $args ); 



    }



}





if ( !function_exists("bindcommerce_get_product_language_code") ) {



    /**

     * 

     * Get BindCommerce products count

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_get_product_language_code($product_id, $str_to_upper = false) {        

        

        if ( BindCommerce_Addons::is_wpml_active() ) { 



            global $sitepress;



            if ($str_to_upper) {



                return strtoupper( $sitepress->get_language_for_element( $product_id, 'post_product' ) );



            } else {



                return $sitepress->get_language_for_element( $product_id, 'post_product' );

                

            }



        }



        if ($str_to_upper) {



            $language_locale = strtoupper(get_locale());



        } else {



            $language_locale = get_locale();

            

        }

        

        return substr($language_locale, 0, strpos($language_locale, '_'));



    }



}





if ( !function_exists("bindcommerce_wpml_get_category_name") ) {



    /**

     * 

     * Get WPML Category language

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_wpml_get_category_name($category_id) {        

        

        if ( BindCommerce_Addons::is_wpml_active() ) { 



            return BindCommerce_DB::get_result("



                SELECT name 

                FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_DB_WP_TERMS . " " . "

                WHERE term_id = '". $category_id . "';



            ");             



        }

        

        return false;



    }



}





if ( !function_exists("bindcommerce_get_attribute_id_by_name") ) {



    /**

     * 

     * Get WPML Category language

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_get_attribute_id_by_name($attribute_name) {        

        

        return BindCommerce_DB::get_result("



            SELECT term_id 

            FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_DB_WP_TERMS . " " . "

            WHERE name = '". $attribute_name . "';



        ");           



    }



}





if ( !function_exists("bindcommerce_has_term_relationship") ) {



    /**

     * 

     * Check if Term taxonomy ID has relationship with Object ID

     * 

     * @since 1.0.0

     * 

     */  

    function bindcommerce_has_term_relationship( $object_id, $term_taxonomy_id ) {



        if ( BindCommerce_Addons::is_wpml_active() ) { 



            $relation = BindCommerce_DB::get_result("



                SELECT object_id 

                FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_DB_WP_TERM_RELATIONSHIPS . " " . "

                WHERE object_id = '". $object_id . "'

                AND term_taxonomy_id = '". $term_taxonomy_id . "';



            ");   



            if (!empty($relation)) {

                return true;

            }



        } 

        return false;



    }





}





if ( !function_exists("bindcommerce_get_exported_products_count") ) {



    /**

     * 

     * Get BindCommerce products count

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_get_exported_products_count() {

        

        $products_count = BindCommerce_DB::get_result("



            SELECT COUNT(sync_id)

            FROM " . DB_NAME . "." . BINDCOMMERCE_DB_WP_PREFIX . BINDCOMMERCE_DB_TABLE_SYNC_EXPORT_PRODUCTS . ";



        ");



        if ( is_numeric($products_count) ) {

            return $products_count;

        }

        

        return 0;



    }



}





if ( !function_exists("bindcommerce_array_to_xml") ) {



    /**

     * 

     * Transform array to XML

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_array_to_xml( $data, $name="root", $export_mode="incremental", &$doc=null, &$node=null ){



        if ($doc==null){

            $doc = new DOMDocument("1.0","UTF-8");

            $doc->formatOutput = TRUE;

            $node = $doc;

        }



        if (is_array($data)){

            foreach($data as $var=>$val){



                if (is_numeric($var)) {



                    bindcommerce_array_to_xml($val, $name, $export_mode, $doc, $node);



                } else {



                    if (!isset($child)){



                        $child = $doc->createElement($name);

                        $node->appendChild($child);

                        

                        if($name == "bindCommerceProducts") {

                            $child->setAttribute( 'Mode', $export_mode );

                        }



                    }



                    bindcommerce_array_to_xml($val, $var, $export_mode, $doc, $child);

                }



            }

        } else {

            $child = $doc->createElement($name);

            $node->appendChild($child);

            $textNode = $doc->createTextNode($data);

            $child->appendChild($textNode);

        }



        if ($doc==$node) {

            return $doc->saveXML();

        }



    }



}







if ( !function_exists("bindcommerce_is_valid_xml") ) {



    /**

     * 

     * Check if variable is a valid XML format

     * 

     * @since 1.0.0

     * 

     */

    function bindcommerce_is_valid_xml($value) {



        $prev = libxml_use_internal_errors(true);

    

        $doc = simplexml_load_string($value);

        $errors = libxml_get_errors();

    

        libxml_clear_errors();

        libxml_use_internal_errors($prev);

    

        return false !== $doc && empty($errors);



    }



}



?>